package horizontalwheelviewwrapper;

import main.java.com.github.shchurov.horizontalwheelview.HorizontalWheelView;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;

import anywheresoftware.b4a.BA.Events;

import android.view.View;
import android.widget.TextView;
import android.widget.ImageView;

import java.util.ArrayList;
import java.util.List;

import android.os.Bundle;

import android.os.Handler;
import android.view.View.OnClickListener;
import android.widget.Button;


@Events(values={"rotation_changed(angle As Double)"})
@Author("Github: Mykhailo Shchurov, Wrapped by: Johan Schoeman")
@Version(1.00f)
@ShortName("HorizontalWheelView")
public class horizontalWheelViewWrapper extends ViewWrapper<HorizontalWheelView> implements DesignerCustomView {


	private BA ba;
	private String eventName;
    private HorizontalWheelView cv;
	
	

	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new HorizontalWheelView(ba.context, null);
        this.setObject(cv);

        setupListeners();

 	}
	
	

    private void setupListeners() {
        cv.setListener(new HorizontalWheelView.Listener() {
            @Override
            public void onRotationChanged(double radians) {
              if (ba.subExists(eventName + "_rotation_changed")) {
				ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_rotation_changed", true, new Object[] {radians});
              }
            }
			
			@Override
			public void onScrollStateChanged(int state) {
				
			}			
        });
    }
	
	
    public void setRadiansAngle(double radians) {
        cv.setRadiansAngle(radians);
		cv.invalidate();
    }

    public void setDegreesAngle(double degrees) {
        cv.setDegreesAngle(degrees);
		cv.invalidate();
    }

    public void setCompleteTurnFraction(double fraction) {
        cv.setCompleteTurnFraction(fraction);
		cv.invalidate();
    }

    public double GetRadiansAngle() {
        return cv.getRadiansAngle();
    }

    public double GetDegreesAngle() {
        return cv.getDegreesAngle();
    }

    public double GetCompleteTurnFraction() {
        return cv.getCompleteTurnFraction();
    }	
	
	
	public void setMaxVisibleMarks(int maxVisibleMarks) {
		cv.setMaxVisibleMarks(maxVisibleMarks);
		cv.invalidate();
	}
	
	public void setNormalColor(int normalColor) {
		cv.setNormalColor(normalColor);
		cv.invalidate();
	}
	
	public void setActiveColor(int activeColor) {
		cv.setActiveColor(activeColor);
		cv.invalidate();
	}

    public void setShowActiveRange(boolean showActiveRange) {
		cv.setShowActiveRange(showActiveRange);
		cv.invalidate();
	}		
	
	
	//programmatically add view
    @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}
	 
}
